package org.diagbot.graphWeb.work;

import org.diagbot.common.javabean.*;
import org.diagbot.common.work.FeatureRate;
import org.diagbot.common.work.ResponseData;
import org.diagbot.common.work.SearchData;
import org.diagbot.nlp.relation.module.Lis;
import org.diagbot.pub.api.Response;
import org.diagbot.pub.utils.PropertiesUtil;
import org.diagbot.pub.utils.http.HttpApi;

import javax.servlet.http.HttpServletRequest;
import java.util.*;

/**
 * 推送诊断和治疗方案
 */
public class DiseaseCalculate {
    public ResponseData getDisease(SearchData searchData) throws Exception {
        ResponseData responseData = new ResponseData();
        PropertiesUtil propertiesUtil = new PropertiesUtil("url.properties");
        //调用图谱API
        HttpApi<ResponseData> api = new HttpApi<>();
        ResponseData diseaseResponse = api.doPost(propertiesUtil.getProperty("disease.http.url"), searchData,
                ResponseData.class);
        //走诊断推送
        List<FeatureRate> dis = (List<FeatureRate>)diseaseResponse.getDis();
        List<FeatureRate> diseaseName = getDisease(dis);
        Map<String, Filnlly> treat = getTreat(diseaseResponse.getTreat());
        responseData.setTreat(treat);
        responseData.setDis(diseaseName);
        return responseData;
    }

    public List<FeatureRate> getDisease(List<FeatureRate> dis){
        List<FeatureRate> diseaseName = new ArrayList<>();
        if(dis != null && dis.size()>0){
            for (FeatureRate d:dis) {
                FeatureRate featureRate = new FeatureRate();
                featureRate.setFeatureName(d.getFeatureName());
                featureRate.setExtraProperty(d.getExtraProperty());
                featureRate.setDesc(d.getDesc());
                featureRate.setRate(d.getRate());
                diseaseName.add(featureRate);
            }
        }
        return diseaseName;
    }

    public Map<String, Filnlly> getTreat(Map<String, Filnlly> treat){
        Map<String,Filnlly> diseaseTreat = new HashMap<String,Filnlly>();
        if(treat != null){
            for (Map.Entry<String, Filnlly> tm:treat.entrySet()) {
                String dise = tm.getKey();
                Filnlly value = tm.getValue();
                List<Indicators> adverseEvent = value.getAdverseEvent();
                ArrayList<Drugs> treatment = value.getTreatment();
                List<Indicators> newAdverseEvent = new ArrayList<>();
                ArrayList<Drugs> newTreatment = new ArrayList<>();
                if(adverseEvent != null && adverseEvent.size()>0){
                    for (Indicators i:adverseEvent) {
                        Indicators indicators = new Indicators();
                        String name = i.getName();
                        Integer controlType = i.getControlType();
                        List<Detail> details = i.getDetails();
                        List<Detail> newDetails = new ArrayList<>();
                        if(details !=null && details.size()>0){
                            for (Detail d:details) {
                                Detail detail = new Detail();
                                String name1 = d.getName();
                                Integer value1 = d.getValue();
                                detail.setName(name1);
                                detail.setValue(value1);
                                newDetails.add(detail);
                            }
                        }
                        indicators.setName(name);
                        indicators.setControlType(controlType);
                        indicators.setDetails(newDetails);
                        newAdverseEvent.add(indicators);
                    }
                }
                if(treatment != null && treatment.size()>0){
                    for (Drugs d:treatment) {
                        Drugs drugs = new Drugs();
                        String bigdrugsName = d.getBigdrugsName();
                        String subdrugsName = d.getSubdrugsName();
                        Integer drugsForbidden = d.getDrugsForbidden();
                        LinkedList<Medicition> medicitionsList = d.getMedicitionsList();
                        LinkedList<Medicition> newMedicitionsList =new LinkedList<>();
                        if(medicitionsList != null && medicitionsList.size()>0){
                            for (Medicition m:medicitionsList) {
                                Medicition newMedication = new Medicition();
                                newMedication.setMedicitionName(m.getMedicitionName());
                                newMedication.setForbidden(m.getForbidden());
                                newMedication.setIsShow(m.getIsShow());
                                newMedication.setRate(m.getRate());
                                newMedicitionsList.add(newMedication);
                            }
                        }
                        drugs.setBigdrugsName(bigdrugsName);
                        drugs.setSubdrugsName(subdrugsName);
                        drugs.setDrugsForbidden(drugsForbidden);
                        drugs.setMedicitionsList(newMedicitionsList);
                        newTreatment.add(drugs);
                    }
                }
                Filnlly filnlly = new Filnlly();
                filnlly.setTreatment(newTreatment);
                filnlly.setAdverseEvent(newAdverseEvent);
                diseaseTreat.put(dise,filnlly);
            }
        }
        return diseaseTreat;
    }
}
